package main;
//import javax.swing.*;
import java.awt.*;

/*
 * Author: Evan May
 * Date: 4/15/07
 * This class does all of the Base-like things, such as displaying, taking damage,
 * and destroying itself as necessary - will be extended into more complex types
 * of buildings later on
 */
public class Base {
	double hitPoints; //how much health the building has
	double damagePoints; //how much damage is done to the building each frame
	String name; //name of the building
	int posX, posY;
	
	public Base(int posX, int posY)
	{
		this.hitPoints = 100;
		this.name = "Basic Building";
		this.damagePoints = 1;
		this.posX = posX;
		this.posY = posY;
	}
	
	/**
	 * Does one round of damage to the building
	 * @return true if the building still lives
	 * 		   false if the building has lost too much health
	 */
	public boolean damageHealth()
	{
		this.hitPoints -= this.damagePoints;
		if (this.hitPoints <= 0)
			return false;
		else
			return true;
	}
	
	public void paint(Graphics2D g2D) {
		int frame = (int) ((100.0 - hitPoints) / 10.0);
		if(frame < 1)
			frame = 1;
		if(frame > 10)
			frame = 10;
		g2D.drawImage(RenderFrame.baseIm.get(frame - 1), posX - 32, posY - 32, RenderFrame.pubFrame);
	}
	
	/** 
	 * Add a certain amount of hitpoints to the building
	 * @param heal amount to be added to the hitpoints
	 */
	public void healHealth(int heal)
	{
		this.hitPoints += heal;
	}
	
}
