package main;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;

/*
 * Author: Evan May
 * Date: 4/15/07
 * This class does all the things that mirrors should do, such as - reflecting
 * light, being selected, being rotated, etc...eventually it will at least
 */
public class Mirror implements MouseListener
{
	static ArrayList<Mirror> allMirror = new ArrayList<Mirror>();	
	private int x, y;
	public LineSeg mirrorSeg;
	
	public Mirror(int x, int y)
	{
		this.x = x - 36;
		this.y = y - 12; //the x and y coordinates of the mirror			
			
		//this.mirrorSeg = new LineSeg(x - 32, y + 12, x + 32, y + 12);
		setAngle(0.0);
		
		allMirror.add(this);
	}
	
	public void setAngle(double theta) {
		this.mirrorSeg = new LineSeg(x - 32 * Math.cos(theta) + 72, y - 32 * Math.sin(theta) + 24, x + 32 * Math.cos(theta) + 72, y + 32 * Math.sin(theta) + 24);
	}
	
	public void paint(Graphics2D g2D)
	{
		AffineTransform mirrorTransform = new AffineTransform();
		mirrorTransform.rotate(mirrorSeg.getTheta(), 36, 12);
		double r = Math.sqrt((x + 36) * (x + 36) + (y + 12) * (y + 12));
		double t = Math.atan2(y + 12, x + 36) - mirrorSeg.getTheta();
		mirrorTransform.translate(r * Math.cos(t), r * Math.sin(t));
		g2D.drawImage(RenderFrame.mirror, mirrorTransform, RenderFrame.pubFrame);
	}
	
	public void lightPaint(Graphics2D g2D) {
		AffineTransform mirrorTransform = new AffineTransform();
		mirrorTransform.rotate(mirrorSeg.getTheta(), 36, 12);
		double r = Math.sqrt((x + 36) * (x + 36) + (y + 12) * (y + 12));
		double t = Math.atan2(y + 12, x + 36) - mirrorSeg.getTheta();
		mirrorTransform.translate(r * Math.cos(t), r * Math.sin(t));
		g2D.drawImage(RenderFrame.mirrorMask, mirrorTransform, RenderFrame.pubFrame);
	}
	
	public void mouseClicked(MouseEvent e) {
				
	}
	
	public void mousePressed(MouseEvent e) {
		
	}
	
	public void mouseReleased(MouseEvent e) {
		
	}
	
	public void mouseEntered(MouseEvent e) {
		
	}
	
	public void mouseExited(MouseEvent e) {
		
	}
	
	public int getX()
	{
		return x;
	}
	
	public int getY()
	{
		return y;
	}
}
